Scriptname din_Utility extends Quest  
{helper functions and properties for Devious Interests}

import StorageUtil

zadlibs Property libs  Auto
zadcLibs Property clibs  Auto

din_Config Property din_cfg  Auto
din_Main Property din_mn  Auto

LeveledItem Property EveryRestraint  Auto

LeveledItem Property Armbinders  Auto
LeveledItem Property ArmCuffs  Auto
LeveledItem Property BreastYoke  Auto
LeveledItem Property Belts  Auto
LeveledItem Property Belts_Open  Auto
LeveledItem Property Blindfolds  Auto
LeveledItem Property Bras  Auto
LeveledItem Property Boots  Auto
LeveledItem Property Catsuits  Auto
LeveledItem Property Collars  Auto
LeveledItem Property Corsets  Auto
LeveledItem Property Corsets_Chastity  Auto
LeveledItem Property Gag_Ball  Auto
LeveledItem Property Gag_Panel  Auto
LeveledItem Property Gag_Ring  Auto
LeveledItem Property Gloves  Auto
LeveledItem Property Harness  Auto
LeveledItem Property HeavyBondage  Auto
LeveledItem Property HobbleDress  Auto
LeveledItem Property HobbleDress_Relaxed  Auto
LeveledItem Property LegCuffs  Auto
LeveledItem Property Mittens  Auto
LeveledItem Property Petsuits  Auto
LeveledItem Property Piercing_Nipple  Auto
LeveledItem Property Piercing_Clitoris  Auto
LeveledItem Property Plug_Anal  Auto
LeveledItem Property Plug_Vag  Auto
LeveledItem Property Straitjackets  Auto
LeveledItem Property Yokes  Auto

LeveledItem Property RestraintList  Auto

MiscObject Property Gold  Auto

LeveledItem Property RandomKey  Auto
LeveledItem Property RandomMinorItem  Auto

FormList Property AllowedKeywords  Auto
FormList Property DDKeywords  Auto
FormList Property ScannedSexPartners  Auto

GlobalVariable Property GameDaysPassed  Auto
GlobalVariable Property PettyCrimeThreshold  Auto

;scanner cloak spell to find nearby potential sex partners
Spell Property FreeUseScanSpell Auto

;==============================================================================================UTILITY START=============================================================================================
;common funcitons and variables used at various places, at various times

;logging functions that print the output into the trace logs
;log levels: INFO, WARNING, ERROR
;logger will be wrapped into LogInfo, LogWarning and LogError
Function Log( String LogMessage )
	Debug.Trace( "[DIN] " + LogMessage )
EndFunction

Function LogInfo( String LogMessage )
	If !din_cfg.LoggingEnabled
		Return
	Else
		Log( "INFO - " + LogMessage )
	EndIf
EndFunction

Function LogWarning( String LogMessage )
	If !din_cfg.LoggingEnabled
		Return
	Else
		Log( "WARNING - " + LogMessage )
	EndIf
EndFunction

Function LogError( String LogMessage )
	If !din_cfg.LoggingEnabled
		Return
	Else
		Log( "ERROR - " + LogMessage )
	EndIf
EndFunction

;used to verify if the actor in question is not performing an action that'd make them unavailable to do something else
Bool Function ValidateActor( actor ActorToValidate )
	;validate basic conditions that'd naturally prevent things from happening
	If ( !ActorToValidate.IsInCombat() && !libs.IsAnimating( ActorToValidate ) && !ActorToValidate.IsDead() && ActorToValidate.GetCurrentScene() == none )
		;events for the player will only process if the intro quest has been finished
		If ActorToValidate == libs.PlayerRef
			;the player will be invalid if the intro quest is running, no events will fire during the intro quest
			If ( Quest.GetQuest( "MQ101" ).GetCurrentStageID() >= 4 && !Quest.GetQuest( "MQ101" ).IsStageDone( 1000 ) )
				Return False
			Else
				Return True
			EndIf
		EndIf
		Return True
	EndIf

	Return False

EndFunction

;used to validate if actor can be selected to fuck the player
Bool Function ValidateSexPartner( actor ActorToValidate )
	If ValidateActor( ActorToValidate )
		If !ActorToValidate.WornHasKeyword( libs.zad_DeviousHeavyBondage ) && !ActorToValidate.WornHasKeyword( libs.zad_DeviousBelt )
			If !ActorToValidate.IsHostileToActor( libs.PlayerRef )
				If !ActorToValidate.IsInCombat()
					If !ActorToValidate.IsGhost()
						Return True
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf

	Return False
	
EndFunction


;used to verify if the container where the restraints are dropped into will spit them back or not
Bool Function ValidateContainer( ObjectReference akDestContainer )
	 ;valid containers are:
	 ;no container, item dropped in the world through the inventory menu
	 ;container type (28), item dropped into it through the container menu
	 ;dead npc type (43), item dropped into their inventory through the container menu
	 ;every other case will not trigger the re-adding of the restraint item to the player's inventory:
	 ;item removed or dropped through script or the item being sold through the barter menu

	 int baseType = 0
	 if akDestContainer != None
		 baseType = akDestContainer.GetBaseObject().GetType()
	 endif
 
	 bool isDead = false
	 Actor deadContainer = akDestContainer as Actor
	 if deadContainer != None
		 isDead = deadContainer.IsDead()
	 endif

	 If ( ( akDestContainer == None && UI.IsMenuOpen( "InventoryMenu" ) ) || ( baseType == 28 && UI.IsMenuOpen( "ContainerMenu" ) ) || ( baseType == 43 && isDead && UI.IsMenuOpen( "ContainerMenu" ) ) )
	 	Return True
	 Else
	 	Return False 	
	 EndIf
EndFunction

;used to quickly check if the player has any sort of restraint keys in her possession
Bool Function HasKeys( actor ActorToValidate )
	;check for every type of DD key in the actor's inventory
	If ( ActorToValidate.GetItemCount( libs.restraintsKey ) > 0  || ActorToValidate.GetItemCount( libs.chastityKey ) > 0 || ActorToValidate.GetItemCount( libs.piercingKey ) > 0 || ActorToValidate.GetItemCount( clibs.zadc_FurnitureKey ) > 0 )
		Return True
	Else
		Return False
	EndIf
EndFunction

;used to check if the actor is in chastity and is not available to be fucked
Bool Function CanBeFucked( actor ActorToValidate )
	If ( ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt ) && !libs.PlayerRef.WornHasKeyword( libs.zad_PermitAnal ) ) && libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBra ) && ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag ) && !libs.PlayerRef.WornHasKeyword( libs.zad_PermitOral ) ) )
		Return False
	Else
		Return True
	EndIf
EndFunction

;used to check if the actor can wear the given restraint based on keywords
Bool Function ValidateRestraint( actor ActorToCheck, Armor Restraint )
	;if the restraint given as argument is none, return instantly
	If Restraint == None
		LogWarning( "Restraint cannot be validated" )
		Return False
	EndIf

	If Restraint.HasKeyword( libs.zad_DeviousCuffsFront ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		;account for prisoner chains
		If Restraint.HasKeyword( libs.zad_DeviousCollar ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousCollar ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousArmCuffs) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousLegCuffs)
			Return True
		ElseIf !Restraint.HasKeyword( libs.zad_DeviousCollar )
			Return True
		EndIf
	ElseIf Restraint.HasKeyword( libs.zad_DeviousPetSuit ) && din_cfg.AllowPetSuits && !ActorToCheck.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousHeavyBondage ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousGag ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousGag )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousBlindfold ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousBlindfold )
		Return True
	;corsets and harnesses block the same slot, check for both
	ElseIf Restraint.HasKeyword( libs.zad_DeviousHarness ) && din_cfg.AllowHarness && !( ActorToCheck.WornHasKeyword( libs.zad_DeviousHarness ) || ActorToCheck.WornHasKeyword( libs.zad_DeviousCorset ) )
		;differentiate between collared and collarless harnesses
		If Restraint.HasKeyword( libs.zad_DeviousCollar ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousCollar )
			Return True
		ElseIf !Restraint.HasKeyword( libs.zad_DeviousCollar )
			Return True
		EndIf		
	ElseIf Restraint.HasKeyword( libs.zad_DeviousCollar ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousCollar )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousArmCuffs ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousArmCuffs )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousLegCuffs ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousLegCuffs )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousBelt ) && ( din_cfg.AllowBelts || din_cfg.AllowBelts_Open ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousBelt )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousBra ) && din_cfg.AllowBras && !ActorToCheck.WornHasKeyword( libs.zad_DeviousBra ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousYokeBB )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousBoots ) && din_cfg.AllowBoots && !ActorToCheck.WornHasKeyword( libs.zad_DeviousBoots )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousElbowTie ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousHobbleSkirt )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousHobbleSkirt ) && (din_cfg.AllowHobbleDress || din_cfg.AllowHobbleDress_Relaxed ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousHobbleSkirt ) && !ActorToCheck.WornHasKeyword( libs.zad_DeviousElbowTie )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousSuit ) && din_cfg.AllowCatsuits && !ActorToCheck.WornHasKeyword( libs.zad_DeviousSuit )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousCorset ) && din_cfg.AllowCorsets && !( ActorToCheck.WornHasKeyword( libs.zad_DeviousHarness ) || ActorToCheck.WornHasKeyword( libs.zad_DeviousCorset ) )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousBondageMittens ) && din_cfg.AllowMittens && !ActorToCheck.WornHasKeyword( libs.zad_DeviousGloves )
		Return True
	ElseIf Restraint.HasKeyword( libs.zad_DeviousGloves ) && din_cfg.AllowGloves && !ActorToCheck.WornHasKeyword( libs.zad_DeviousGloves )
		Return True
	;check for chastity corsets separately
	ElseIf Restraint.HasKeyword( libs.zad_DeviousCorset ) && Restraint.HasKeyword( libs.zad_DeviousBelt ) && ( din_cfg.AllowCorsets_Chastity ) && !( ( ActorToCheck.WornHasKeyword( libs.zad_DeviousHarness ) || ActorToCheck.WornHasKeyword( libs.zad_DeviousCorset ) ) && ActorToCheck.WornHasKeyword( libs.zad_DeviousBelt ) )
		Return True
	;plugs and piercings cannot go through chastity belts and bras	
	ElseIf Restraint.HasKeyword( libs.zad_DeviousPiercingsNipple ) && din_cfg.AllowPiercing_Nipple && !( ActorToCheck.WornHasKeyword( libs.zad_DeviousBra ) || ActorToCheck.WornHasKeyword( libs.zad_DeviousPiercingsNipple ) )
		Return True
	ElseIf Restraint.HasKeyword(  libs.zad_DeviousPiercingsVaginal ) && din_cfg.AllowPiercing_Clit && !( ActorToCheck.WornHasKeyword( libs.zad_DeviousBelt ) || ActorToCheck.WornHasKeyword( libs.zad_DeviousPiercingsVaginal ) )
		Return True			
	ElseIf Restraint.HasKeyword( libs.zad_DeviousPlugVaginal ) && din_cfg.AllowPlugs && !( ActorToCheck.WornHasKeyword( libs.zad_DeviousBelt ) || ActorToCheck.WornHasKeyword( libs.zad_DeviousPlugVaginal ) )
		Return True	
	ElseIf Restraint.HasKeyword( libs.zad_DeviousPlugAnal ) && din_cfg.AllowPlugs && !( ActorToCheck.WornHasKeyword( libs.zad_DeviousBelt ) || ActorToCheck.WornHasKeyword(libs.zad_DeviousPlugAnal ) )
		Return True
	EndIf

	;if none of the conditions above are met, the restraint is invalid on the given actor
	LogInfo( "Restraint to validate is invalid" )
	Return False
EndFunction

;provides the number of restraints the actor is currently wearing
Int Function GetRestraintNum( Actor ActorToCheck )
	
	Int RestraintNum = 0

	;if the actor is not wearing any restraints, return 0 instantly
	If !ActorToCheck.WornHasKeyword( libs.zad_Lockable )
		Return 0
	EndIf

	;the number of iterations in the cycle will correspond to the number of keywords to check
	Int i = DDKeywords.GetSize()

	While i >= 0	
		If ActorToCheck.WornHasKeyword( DDKeywords.GetAt( i - 1 ) as Keyword )
			;if true, increment the worn restraint number by 1
			RestraintNum += 1		
		EndIf
		i -= 1
	EndWhile

	Return RestraintNum

EndFunction

;scans the actor's inventory for unequipped restraints
Function GetRestraintsInInventory( Actor ActorToCheck )
	
	RestraintList.Revert()

	;check the total number of items in the inventory
	Int i = ActorToCheck.GetNumItems()
	Form item = None

	While i >= 0
		item = ActorToCheck.GetNthForm( i - 1 )
		;process only for armor type forms
		If item != None && item.GetType() == 26
			;process only for DD inventory devices
			If item.HasKeyword( libs.zad_InventoryDevice )
				If din_cfg.IsLBSInstalled
					;if Laura's Bondage Shop is installed, a unique yoke can be equipped too, even though it's a quest item
					If item.HasKeywordString( "Laura_SR1_Device" )
						LogInfo( "Found Sirrina's Yoke from LBS to equip" )
						;add this to the pool of restraints
						RestraintList.AddForm( item, 1, 1 )
					;otherwise check if it is a non-quest restraint and if so, add it to the list
					ElseIf !item.HasKeyword( libs.zad_BlockGeneric )
						;if all of this apply, add this to the pool of restraints
						RestraintList.AddForm( item, 1, 1 )
					EndIf
					;process only for generic devices
				ElseIf !item.HasKeyword( libs.zad_BlockGeneric )
					;if all of this apply, add this to the pool of restraints
					RestraintList.AddForm( item, 1, 1 )
				EndIf
			Endif
		EndIf
		i -= 1
	EndWhile
EndFunction

;equips a random restraint form the actor's inventory
Bool Function EquipRandomRestraintFromInventory( Actor ActorToCheck )
	;get all the restraint items from the actor's inventory, put them in RestraintList
	GetRestraintsInInventory( ActorToCheck )

	Int itemnum = 0

	Int RestListLength = RestraintList.GetNumForms()

	If RestListLength == 0
		Return False
	Else
		;get the number of items to equip
		itemnum = Utility.RandomInt( 1, RestListLength )
	EndIf

	Int i = 0
	Int NumRestraintsEquipped = 0
	Armor RestraintSelectedInv = None
	Armor RestraintSelectedRen = None
	;select a random number of items from the filled RestraintList and equip it
	;do the loop until we got the required number of restraints or the list has run out
	While ( NumRestraintsEquipped < itemnum && i < RestListLength )

		RestraintSelectedInv = RestraintList.GetNthForm( i ) as Armor
		RestraintSelectedRen = libs.GetRenderedDevice( RestraintSelectedInv )

		If RestraintSelectedInv && RestraintSelectedRen
			If ValidateRestraint( libs.PlayerRef, RestraintSelectedRen )
				libs.LockDevice( ActorToCheck, RestraintSelectedInv, false )
				;if the equip is successful, mark one item as done
				NumRestraintsEquipped += 1
			EndIf
		EndIf
		i += 1
	EndWhile

	If NumRestraintsEquipped == 0
		Return False
	Else
		Return True
	EndIf
EndFunction

;utility function to traverse nested leveled lists and select a random item from them
Form Function SelectFromLeveledList( LeveledItem List )

	;pick one from the appropriate restraint items
	Form temp = None
	Int list_length = List.GetNumForms()
	Int nth_form = Utility.RandomInt( 0, list_length - 1 )
	temp = List.GetNthForm( nth_form )

	If ( temp as LeveledItem )
		;select item and traverse nested leveled lists until one is found
		Int i = 0
		While ( ( temp as LeveledItem ) == none && i < list_length )
			nth_form += 1
			If ( nth_form >= list_length )
				nth_form = 0
			EndIf
			temp = RestraintList.GetNthForm( nth_form )
			i += 1
		EndWhile
	
		While ( temp As Armor ) == None && ( temp as LeveledItem )
			list_length = ( temp As LeveledItem ).GetNumForms() - 1
			nth_form = Utility.RandomInt( 0, list_length )
			temp = (temp As LeveledItem).GetNthForm( nth_form )
		EndWhile
	EndIf
	
	If ( temp )
		Return temp
	Else
		Return None
	EndIf

EndFunction

;select a specific restraint type to be equipped, based on the argument
Armor Function GetRestraintToEquip( Keyword RestraintKeyword )

	Armor SelectedRestraint = None

	RestraintList.Revert()

	If RestraintKeyword == libs.zad_DeviousArmbinder
		SelectedRestraint = SelectFromLeveledList( Armbinders ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousArmCuffs 
		SelectedRestraint = SelectFromLeveledList( ArmCuffs ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousYokeBB 
		SelectedRestraint = SelectFromLeveledList( BreastYoke ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousBelt
		;check for allowed belt types
		If din_cfg.AllowBelts
			RestraintList.AddForm( Belts, 1, 1 )
		EndIf
		If din_cfg.AllowBelts_Open
			RestraintList.AddForm( Belts_Open, 1, 1 )
		EndIf

		SelectedRestraint = SelectFromLeveledList( RestraintList ) as Armor

	ElseIf RestraintKeyword == libs.zad_DeviousBlindfold
		SelectedRestraint = SelectFromLeveledList( Blindfolds ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousBra 
		SelectedRestraint = SelectFromLeveledList( Bras ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousBoots
		SelectedRestraint = SelectFromLeveledList( Boots ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousSuit
		SelectedRestraint = SelectFromLeveledList( Catsuits ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousCollar 
		SelectedRestraint = SelectFromLeveledList( Collars ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousCorset 
		SelectedRestraint = SelectFromLeveledList( Corsets ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousGag
		;check for allowed gag types
		If din_cfg.AllowGag_Ball
			RestraintList.AddForm( Gag_Ball, 1, 1 )
		EndIf
		If din_cfg.AllowGag_Panel
			RestraintList.AddForm( Gag_Panel, 1, 1 )
		EndIf
		If din_cfg.AllowGag_Ring
			RestraintList.AddForm( Gag_Ring, 1, 1 )
		EndIf

		SelectedRestraint = SelectFromLeveledList( RestraintList ) as Armor

	ElseIf RestraintKeyword == libs.zad_DeviousBondageMittens
		SelectedRestraint = SelectFromLeveledList( Mittens ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousGloves
		SelectedRestraint = SelectFromLeveledList( Gloves ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousHarness
		SelectedRestraint = SelectFromLeveledList( Harness ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousHeavyBondage
		SelectedRestraint = SelectFromLeveledList( HeavyBondage ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousHobbleSkirt
		;check for allowed hobble dress types
		If din_cfg.AllowHobbleDress
			RestraintList.AddForm( HobbleDress, 1, 1 )
		EndIf
		If din_cfg.AllowHobbleDress_Relaxed
			RestraintList.AddForm( HobbleDress_Relaxed, 1, 1 )
		EndIf

		SelectedRestraint = SelectFromLeveledList( RestraintList ) as Armor

	ElseIf RestraintKeyword == libs.zad_DeviousLegCuffs 
		SelectedRestraint = SelectFromLeveledList( LegCuffs ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousPetSuit
		SelectedRestraint = SelectFromLeveledList( Petsuits ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousPiercingsVaginal 
		SelectedRestraint = SelectFromLeveledList( Piercing_Clitoris ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousPiercingsNipple 
		SelectedRestraint = SelectFromLeveledList( Piercing_Nipple ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousPlugAnal
		SelectedRestraint = SelectFromLeveledList( Plug_Anal ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousPlugVaginal 
		SelectedRestraint = SelectFromLeveledList( Plug_Vag ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousStraitJacket 
		SelectedRestraint = SelectFromLeveledList( Straitjackets ) as Armor
	ElseIf RestraintKeyword == libs.zad_DeviousYoke 
		SelectedRestraint = SelectFromLeveledList( Yokes ) as Armor
	EndIf

	Return SelectedRestraint

EndFunction

;select a random restraint to be equipped based on what the player is wearing and what is allowed in the MCM
Armor Function GetRandomRestraintToEquip()

	;clear the list of possible restraints
	RestraintList.Revert()

	;add the appropriate leveled lists to the master leveled list
	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmbinder ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( Armbinders, 1, 1 )
	EndIf

	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmCuffs )
		RestraintList.AddForm( ArmCuffs, 1, 1 )
	EndIf

	If din_cfg.AllowBreastYoke && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousYokeBB ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBra ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( BreastYoke, 1, 1 )
	EndIf

	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt )
		;check for allowed belt types
		If din_cfg.AllowBelts
			RestraintList.AddForm( Belts, 1, 1 )
		EndIf
		If din_cfg.AllowBelts_Open
			RestraintList.AddForm( Belts_Open, 1, 1 )
		EndIf
	EndIf

	If din_cfg.AllowBras && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBra )
		RestraintList.AddForm( Bras, 1, 1 )
	EndIf

	If din_cfg.AllowBoots && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBoots )
		RestraintList.AddForm( Boots, 1, 1 )
	EndIf

	If din_cfg.AllowCatsuits && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousSuit )
		RestraintList.AddForm( Catsuits, 1, 1 )
	EndIf

	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousCollar )
		RestraintList.AddForm( Collars, 1, 1 )
	EndIf

	;corsets and harnesses cannot be worn together
	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousCorset ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHarness )
		;check for allowed corset types
		If din_cfg.AllowCorsets
			RestraintList.AddForm( Corsets, 1, 1 )
		EndIf
		;allow chastity corsets only if they are enabled and the player is not wearing a chastity belt (or equivalent)
		If ( din_cfg.AllowCorsets_Chastity && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt ) )
			RestraintList.AddForm( Corsets_Chastity, 1, 1 )
		EndIf
	EndIf

	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag )
		;check for allowed gag types
		If din_cfg.AllowGag_Ball
			RestraintList.AddForm( Gag_Ball, 1, 1 )
		EndIf
		If din_cfg.AllowGag_Panel
			RestraintList.AddForm( Gag_Panel, 1, 1 )
		EndIf
		If din_cfg.AllowGag_Ring
			RestraintList.AddForm( Gag_Ring, 1, 1 )
		EndIf
	EndIf

	If din_cfg.AllowMittens && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGloves )
		RestraintList.AddForm( Mittens, 1, 1 )
	EndIf

	If din_cfg.AllowGloves && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGloves )
		RestraintList.AddForm( Gloves, 1, 1 )
	EndIf

	;harnesses and corsets cannot be worn together
	If din_cfg.AllowHarness && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHarness ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousCorset )
		RestraintList.AddForm( Harness, 1, 1 )
	EndIf

	If din_cfg.AllowHeavyBondage && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( HeavyBondage, 1, 1 )
	EndIf

	If !( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHobbleSkirt ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHobbleSkirtRelaxed ) )
		;check for allowed hobble dress types
		If din_cfg.AllowHobbleDress
			RestraintList.AddForm( HobbleDress, 1, 1 )
		EndIf
		If din_cfg.AllowHobbleDress_Relaxed
			RestraintList.AddForm( HobbleDress_Relaxed, 1, 1 )
		EndIf
	EndIf

	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousLegCuffs )
		RestraintList.AddForm( LegCuffs, 1, 1 )
	EndIf

	If din_cfg.AllowPetSuits && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPetSuit )
		RestraintList.AddForm( Petsuits, 1, 1 )
	EndIf

	If din_cfg.AllowPiercing_Nipple && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPiercingsNipple )
		;nipple piercings can only be added if they aren't blocked by a chastity bra
		If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBra )
			RestraintList.AddForm( Piercing_Nipple, 1, 1 )
		EndIf
	EndIf

	If din_cfg.AllowPiercing_Clit && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPiercingsVaginal ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt )
		;clitoris piercings can only be added if the player is not wearing a chastity belt
		RestraintList.AddForm( Piercing_Clitoris, 1, 1 )
	EndIf

	If din_cfg.AllowPlugs && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugAnal )
		;anal plugs can only be added if the player is not wearing a chastity belt or is wearing an open-back one
		If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt ) || libs.PlayerRef.WornHasKeyword( libs.zad_PermitAnal )
			RestraintList.AddForm( Plug_Anal, 1, 1 )
		EndIf
	EndIf

	If din_cfg.AllowPlugs && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugVaginal ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt )
		;vaginal plugs can only be added if the player is not wearing a chastity belt
		RestraintList.AddForm( Plug_Vag, 1, 1 )
	EndIf
	
	If din_cfg.AllowStraitjackets && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousStraitJacket ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage ) 
		RestraintList.AddForm( Straitjackets, 1, 1 )
	EndIf

	If din_cfg.AllowYokes && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousYoke ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( Yokes, 1, 1 )
	EndIf

	Armor RestraintSelected = None

	Int i = 0

	;select a suitable restraint from the leveled list
	While ( !ValidateRestraint( libs.PlayerRef, libs.GetRenderedDevice( RestraintSelected ) ) && i < RestraintList.GetNumForms() )
		RestraintSelected = SelectFromLeveledList( RestraintList ) as Armor
		i += 1
	EndWhile

	Return RestraintSelected
	
EndFunction


;same as above but specifically for armbindings
Armor Function GetRandomArmbinding()

	;clear the list of possible restraints
	RestraintList.Revert()

	;add the appropriate leveled lists to the master leveled list
	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmbinder ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( Armbinders, 1, 1 )
	EndIf

	If din_cfg.AllowBreastYoke && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousYokeBB ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( BreastYoke, 1, 1 )
	EndIf


	If din_cfg.AllowHeavyBondage && !( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage ) && libs.PlayerRef.WornHasKeyword( libs.zad_DeviousArmCuffs ) && libs.PlayerRef.WornHasKeyword( libs.zad_DeviousLegCuffs ) )
		RestraintList.AddForm( HeavyBondage, 1, 1 )
	EndIf
	
	If din_cfg.AllowStraitjackets && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousStraitJacket )
		RestraintList.AddForm( Straitjackets, 1, 1 )
	EndIf

	If din_cfg.AllowYokes && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousYoke ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage )
		RestraintList.AddForm( Yokes, 1, 1 )
	EndIf

	Armor RestraintSelected = SelectFromLeveledList( RestraintList ) as Armor

	Return RestraintSelected

EndFunction


;create a set of items to equip based on the given parameters
Function CreateAndEquipRestraintSet( String Severity )

	;reset the list of allowed keywords used to determine restraint types
	AllowedKeywords.Revert()

	;no special conidtion for light bondage set
	;collars and cuffs are always allowed
	libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousArmCuffs ) )
	libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousLegCuffs ) )
	libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousCollar ) )
	Utility.Wait( 0.5 )

	;add restraint keywords based on mcm settings to pick extra restraints
	If din_cfg.AllowBoots
		AllowedKeywords.AddForm( libs.zad_DeviousBoots )
	EndIf

	If din_cfg.AllowCorsets
		AllowedKeywords.AddForm( libs.zad_DeviousCorset )
	EndIf

	If din_cfg.AllowGloves
		AllowedKeywords.AddForm( libs.zad_DeviousGloves )
	EndIf

	If din_cfg.AllowPiercing_Nipple
		AllowedKeywords.AddForm( libs.zad_DeviousPiercingsNipple )
	EndIf

	If din_cfg.AllowPiercing_Clit
		AllowedKeywords.AddForm( libs.zad_DeviousPiercingsVaginal )
	EndIf

	If ( Severity == "medium" || Severity == "heavy" )
		;add a gag
		libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousGag ) )
		Utility.Wait( 0.5 )

		If ( din_cfg.AllowBelts || din_cfg.AllowBelts_Open )
			AllowedKeywords.AddForm( libs.zad_DeviousBelt )
		EndIf
		If din_cfg.AllowBras
			AllowedKeywords.AddForm( libs.zad_DeviousBra )
		EndIf
		If din_cfg.AllowHarness
			AllowedKeywords.AddForm( libs.zad_DeviousHarness )
		EndIf
		If din_cfg.AllowPlugs
			AllowedKeywords.AddForm( libs.zad_DeviousPlugAnal )
			AllowedKeywords.AddForm( libs.zad_DeviousPlugVaginal )
		EndIf
	EndIf

	;equip some random extra gear if we got any
	Keyword SelectedKeyword = none
	Armor RestraintToEquip = none
	Int i = 0

	If ( !AllowedKeywords.GetSize() == 0 )

		Int NumIterations = Utility.RandomInt( 1, 3 )
		If ( AllowedKeywords.GetSize() < 3 )
			NumIterations = 2
		EndIf

		While i < NumIterations
			SelectedKeyword = AllowedKeywords.GetAt( Utility.RandomInt( 0, AllowedKeywords.GetSize() - 1 ) ) as Keyword
			If ( !libs.PlayerRef.WornHasKeyword( SelectedKeyword ) )
				RestraintToEquip = GetRestraintToEquip( SelectedKeyword )
				;if a belt is selected, also equip plugs, if allowed
				If ( libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_DeviousBelt ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugVaginal ) && din_cfg.AllowPlugs && din_cfg.AddPlugWithBelt )
					;equip an anal plug only if the belt is not open-back
					If ( !libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_PermitAnal ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlugAnal ) )
						libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousPlugAnal ) )
					EndIf
					libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousPlugVaginal ) )
				EndIf
				libs.LockDevice( libs.PlayerRef, RestraintToEquip )
				;if a plug is selected, also equip a chastity belt for good measure, if allowed
				If ( libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_DeviousPlugVaginal ) && ( din_cfg.AllowBelts || din_cfg.AllowBelts_Open ) )
					libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousBelt ) )
				EndIf
				If ( libs.GetRenderedDevice( RestraintToEquip ).HasKeyword( libs.zad_DeviousPlugAnal ) && din_cfg.AllowBelts )
					libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousBelt ) )
				EndIf
				;remove the used keyword to not get duplicates
				AllowedKeywords.RemoveAddedForm( SelectedKeyword )
				i += 1
			Else
				AllowedKeywords.RemoveAddedForm( SelectedKeyword )
			EndIf
		EndWhile
	EndIf

	If ( Severity == "heavy" || Severity == "sex" )
		AllowedKeywords.Revert()

		;add a wrist restraint
		libs.LockDevice( libs.PlayerRef, GetRandomArmbinding() )

		;add a blindfold
		libs.LockDevice( libs.PlayerRef, GetRestraintToEquip( libs.zad_DeviousBlindfold ) )
		Utility.Wait( 0.5 )
	EndIf

EndFunction


;the player drops all her keys, which are lost consequently
Function DropPlayerKeys()
	libs.PlayerRef.RemoveItem( libs.restraintsKey, libs.PlayerRef.GetItemCount( libs.restraintsKey ) )
	libs.PlayerRef.RemoveItem( libs.chastityKey, libs.PlayerRef.GetItemCount( libs.chastityKey) )
	libs.PlayerRef.RemoveItem( libs.piercingKey, libs.PlayerRef.GetItemCount( libs.piercingKey) )
	libs.PlayerRef.RemoveItem( clibs.zadc_FurnitureKey, libs.PlayerRef.GetItemCount( clibs.zadc_FurnitureKey) )
EndFunction


;performs checks and returns if the player is visibly bound or not
Bool Function CheckVisiblyBound()
	;restraints that cannot be hidden by clothes or armor:
	;heavy bondage items (yoke, armbinder, shackles, etc.)
	;- suits (catsuit, hobbledress, straitjacket, etc.)
	;- gag
	;- blindfold
	;- ankle shackles
	;- hoods
	;- slave boots
	;- collar
	If ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage ) || ( libs.PlayerRef.WornHasKeyword( libs.zad_DeviousGag ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBlindfold ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousCollar ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBoots ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousSuit ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousAnkleShackles ) || libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHood ) ) )
		Return True
	;other restraints can be hidden if clothing or armor is worn over them
	ElseIf ( libs.PlayerRef.WornHasKeyword( libs.zad_Lockable ) && ( !libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ClothingBody" ) ) && !libs.PlayerRef.WornHasKeyword( Keyword.GetKeyword( "ArmorCuirass" ) ) ) )
		Return True
	Else
		Return False
	EndIf	
EndFunction

;cum encumbrance perks
Spell Property CumEncumbranceLvl1  Auto
Spell Property CumEncumbranceLvl2  Auto
Spell Property CumEncumbranceLvl3  Auto
Spell Property CumEncumbranceLvl4  Auto
Spell Property CumEncumbranceLvl5  Auto

;handles cum inflation and deflation of the player
Function Cumflation( Int NumberOfLoads )

	;math for cumflation:
	;max belly size: 1.0 in PregnancyBelly slider value by default
	;minimum belly size: 1 load of cum increases the PregnancyBelly slider value by 0.05 unit
	;for every 0.1 increase in PregnancyBelly, there will be a 0.05 decrease in TummyTuck to make a nicely belly form

	Float CurrentCumflationLevel = GetFloatValue( libs.PlayerRef, "CumflationLevel" )
	LogInfo( "The player's current cum inflation level is: " + CurrentCumflationLevel )

	If ( CurrentCumflationLevel == din_cfg.CumBellySize && NumberOfLoads > 0 )
		;player is fully inflated, belly cannot grow any larger
		Debug.Notification( "Your womb cannot hold any more cum!" )
		libs.SexLab.AddCum( libs.PlayerRef, true, false, true )
		Return
	EndIf
	
	;this is the max size the player's belly will grow to after taking cum
	Float InflationTarget = CurrentCumflationLevel + ( ( NumberOfLoads as Float ) / 20 )
	;if the target inflation is higher than the max size set in the config, max size will be the target
	If InflationTarget > din_cfg.CumBellySize
		InflationTarget = din_cfg.CumBellySize
	EndIf
	LogInfo( "The player's belly will be inflated to: " + InflationTarget )

	SetFloatValue( libs.PlayerRef, "CumflationLevel", InflationTarget )

	;inflate or adjust
	If InflationTarget != 0.0
		If din_cfg.IsSLIFInstalled
			SLIF_Morph.morph( libs.PlayerRef, "DeviousInterests.esp", "PregnancyBelly", InflationTarget )
			SLIF_Morph.morph( libs.PlayerRef, "DeviousInterests.esp", "TummyTuck", ( -1 * InflationTarget ) )
		Else
			NiOverride.SetBodyMorph( libs.PlayerRef, "PregnancyBelly", "DeviousInterests.esp", InflationTarget )
			NiOverride.SetBodyMorph( libs.PlayerRef, "TummyTuck", "DeviousInterests.esp", ( -1 * InflationTarget ) )
		EndIf
	;deflate to zero
	Else
		If din_cfg.IsSLIFInstalled
			SLIF_Morph.unregisterMorph( libs.PlayerRef, "PregnancyBelly", "DeviousInterests.esp" )
			SLIF_Morph.unregisterMorph( libs.PlayerRef, "TummyTuck", "DeviousInterests.esp" )
		Else
			NiOverride.ClearBodyMorph( libs.PlayerRef, "PregnancyBelly", "DeviousInterests.esp" )
			NiOverride.ClearBodyMorph( libs.PlayerRef, "TummyTuck", "DeviousInterests.esp" )
		EndIf
	EndIf	
	NiOverride.UpdateModelWeight( libs.PlayerRef )

	;clear cum encumbrance perks
	libs.PlayerRef.DispelSpell( CumEncumbranceLvl1 )
	libs.PlayerRef.DispelSpell( CumEncumbranceLvl2 )
	libs.PlayerRef.DispelSpell( CumEncumbranceLvl3 )
	libs.PlayerRef.DispelSpell( CumEncumbranceLvl4 )
	libs.PlayerRef.DispelSpell( CumEncumbranceLvl5 )

	;check which perks need to be added based on cum inflation status
	If InflationTarget >= ( din_cfg.CumBellySize / 5 ) && InflationTarget < ( din_cfg.CumBellySize / 2.5 )
		libs.PlayerRef.AddSpell( CumEncumbranceLvl1, false )
	ElseIf InflationTarget >= ( din_cfg.CumBellySize / 2.5 ) && InflationTarget < ( din_cfg.CumBellySize / 1.67 )
		libs.PlayerRef.AddSpell( CumEncumbranceLvl2, false )
	ElseIf InflationTarget >= ( din_cfg.CumBellySize / 1.67 ) && InflationTarget < ( din_cfg.CumBellySize / 1.25 )
		libs.PlayerRef.AddSpell( CumEncumbranceLvl3, false )
	ElseIf InflationTarget >= ( din_cfg.CumBellySize / 1.25 ) && InflationTarget < ( din_cfg.CumBellySize )
		libs.PlayerRef.AddSpell( CumEncumbranceLvl4, false )
	ElseIf InflationTarget == din_cfg.CumBellySize
		libs.PlayerRef.AddSpell( CumEncumbranceLvl5, false )
	EndIf

EndFunction


;call with very specific parameters that clears all cum inflation if the feature is disabled
Function ClearCumflation()
	If GetFloatValue( libs.PlayerRef, "CumflationLevel" ) != 0.0
		NiOverride.ClearBodyMorph( libs.PlayerRef, "PregnancyBelly", "DeviousInterests.esp")
		NiOverride.ClearBodyMorph( libs.PlayerRef, "TummyTuck", "DeviousInterests.esp")
		NiOverride.UpdateModelWeight( libs.PlayerRef )
		SetFloatValue( libs.PlayerRef, "CumflationLevel", 0.0 )
	EndIf
EndFunction


;update unlock cost globals in dialogue
Function UpdateUnlockCostGlobals()

	If !UpdateCurrentInstanceGlobal( din_cfg.Global_UnlockCost )
		LogError( "Failed to update global for unlock cost basic" )
	EndIf

	If !UpdateCurrentInstanceGlobal( din_cfg.Global_UnlockCostReg )
		LogError( "Failed to update global for unlock cost regular" )
	EndIf

	If !UpdateCurrentInstanceGlobal( din_cfg.Global_UnlockCostAdv )
		LogError( "Failed to update global for unlock cost advanced" )
	EndIf
	
EndFunction

;===============================================================================================UTILITY END==============================================================================================

;================================================================================================SEX START===============================================================================================
;store stripped chastity belt and plugs for sex scenes
Armor StrippedBelt = None
Armor StrippedVPlug = None
Armor StrippedAPlug = None

;called when NPC decides to use the player as a fucktoy
;also removes chastity belts and plugs if needed and possible
Bool Function FuckPlayer( Actor Partner, Bool consensual = True, String TagsToInclude = "", String TagsToSuppress = "" )

	SendModEvent( "dhlp-Suspend" )

	libs.PlayerRef.SetRestrained()

	;holds the victim if it's not a consensual scene
	Actor Victim = None

	;holds the after sex scene hook
	String Hook = None

	libs.SexLab.StripActor( libs.PlayerRef, DoAnimate = false )
	
	;check for chastity belts and try to strip it only if not consensual scene
	If ( consensual == False )
		Victim = libs.PlayerRef
		;only unlock chastity belts and register for followup events if there are no creatures involved
		If !( Partner.HasKeywordString( "ActorTypeAnimal" ) || Partner.HasKeywordString( "ActorTypeCreature" ) )
			If libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt )
				RemoveBeltAndPlugs( Partner )
			EndIf
			;register for the hooked event
			RegisterforModEvent( "HookAnimationEnd_AfterSex", "AfterSexHook" )
			Hook = "AfterSex"
		EndIf
	EndIf

	;starting tags, to be expanded based on tags in parameters and partner sex
	String IncludeTags = ""
	String SuppressTags = "foreplay"

	;try to setup a gangbang if they are enabled
	If ( din_cfg.GangBangChance > 0.0 )
		If Gangbang( Partner, Victim, Hook )
			SendModEvent( "dhlp-Resume" )
			libs.PlayerRef.SetRestrained( false )
			Return True
		EndIf
	EndIf

	Actor[] SexActors = new Actor[2]
	SexActors[0] = libs.PlayerRef
	SexActors[1] = Partner
	
	;get the sex of the NPC, for proper animation selection
	If Partner.GetLeveledActorBase().GetSex() == 1
		;this is the partner = female branch, lesbian animations are preferable if available
		IncludeTags = TagsToInclude + ",FF"
		SuppressTags += TagsToSuppress
		;check if there are available proper lesbian animations
		sslBaseAnimation[] SAnims = libs.SelectValidDDAnimations( SexActors, 2, false, IncludeTags, SuppressTags )
		;if there aren't, revert the addition of the FF tag
		If Sanims.Length <= 0
			LogInfo( "No suitable lesbian animation found, clearing tags" )
			IncludeTags = TagsToInclude
		EndIf
	ElseIf Partner.GetLeveledActorBase().GetSex() == 0
		;this is the parter = male branch, lesbian animations are suppressed
		IncludeTags = TagsToInclude
		;go for vaginal animations if a chastity belt was unlocked
		If StrippedBelt
			IncludeTags += ",vaginal"
		EndIf
		SuppressTags += TagsToSuppress + ",lesbian,FF"
	EndIf
	
	If libs.StartValidDDAnimation( SexActors = SexActors, includetag = IncludeTags, suppresstag = SuppressTags, victim = Victim, hook = Hook )
		libs.PlayerRef.SetRestrained( false )
		SendModEvent( "dhlp-Resume" )
		Return True
	Else
		libs.PlayerRef.SetRestrained( false )
		SendModEvent( "dhlp-Resume" )

		ReleaseEncounter() ; FLEN

		Return False
	EndIf

EndFunction

;handles the removal of chastity belts and plugs
Function RemoveBeltAndPlugs( Actor Unlocker )

	Armor BeltToStrip = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousBelt )

	;chastity harnesses won't be found by the function call above
	;if we are in this function but no chastity belt was found, the player is wearing a chastity harness
	If !BeltToStrip
		BeltToStrip = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousHarness )
	EndIf
		
	If !BeltToStrip.HasKeyword( libs.zad_BlockGeneric )
		;take and use key to unlock the belt if the player has one
		If libs.PlayerRef.GetItemCount( libs.chastityKey ) >= 1
			Armor BeltToStripRendered = libs.GetRenderedDevice( BeltToStrip )
			;remove the key only if the unlock is successful
			If libs.UnlockDevice( libs.PlayerRef, BeltToStrip, BeltToStripRendered, libs.zad_DeviousBelt, true, true )
				libs.PlayerRef.RemoveItem( libs.chastityKey, 1 )
				StrippedBelt = BeltToStrip
				Debug.Notification( Unlocker.GetLeveledActorBase().GetName() + " took a key you were carrying and managed to unlock your chastity belt!" )
			EndIf
		ElseIf Unlocker.GetItemCount( libs.chastityKey ) >= 1
			Armor BeltToStripRendered = libs.GetRenderedDevice( BeltToStrip )
			;remove the key only if the unlock is successful
			If libs.UnlockDevice( libs.PlayerRef, BeltToStrip, BeltToStripRendered, libs.zad_DeviousBelt, true, true )
				Unlocker.RemoveItem( libs.chastityKey, 1 )
				StrippedBelt = BeltToStrip
				Debug.Notification( Unlocker.GetLeveledActorBase().GetName() + " used a key they were carrying and managed to unlock your chastity belt!" )
			EndIf	
		Endif
	Endif

	Utility.Wait( 0.1 )
		
	;check for plugs and try to strip them
	;plugs will only be stripped if the player is not wearing a chastity belt, otherwise removal is unrealistic
	If libs.PlayerRef.WornHasKeyword( libs.zad_DeviousPlug ) && !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousBelt )

		Armor VPlugToStrip = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousPlugVaginal )
		Armor APlugToStrip = libs.GetWornDevice( libs.PlayerRef, libs.zad_DeviousPlugAnal )

		If VPlugToStrip && !VPlugToStrip.HasKeyword( libs.zad_BlockGeneric )
			;check if it's a locking plug, only unlocked with a chastity key
			If VPlugToStrip.HasKeyword( libs.zad_Lockable )
				If libs.PlayerRef.GetItemCount( libs.chastityKey ) >= 1
					Armor VPlugToStripRendered = libs.GetRenderedDevice( VPlugToStrip )
					libs.PlayerRef.RemoveItem( libs.chastityKey, 1 )
					libs.UnlockDevice( libs.PlayerRef, VPlugToStrip, VPlugToStripRendered, libs.zad_DeviousPlugVaginal, true, true )
					StrippedVPlug = VPlugToStrip
					Debug.Notification( Unlocker.GetLeveledActorBase().GetName() + " took a key you were carrying and managed to unlock your vaginal plug!" )
				ElseIf Unlocker.GetItemCount( libs.chastityKey ) >= 1
					Armor VPlugToStripRendered = libs.GetRenderedDevice( VPlugToStrip )
					Unlocker.RemoveItem( libs.chastityKey, 1 )
					libs.UnlockDevice( libs.PlayerRef, VPlugToStrip, VPlugToStripRendered, libs.zad_DeviousPlugVaginal, true, true )
					StrippedVPlug = VPlugToStrip
					Debug.Notification( Unlocker.GetLeveledActorBase().GetName() + " used a key they were carrying and managed to unlock your vaginal plug!" )
				EndIf
			Else			
				Armor VPlugToStripRendered = libs.GetRenderedDevice( VPlugToStrip )
				StrippedVPlug = VPlugToStrip
				libs.UnlockDevice( libs.PlayerRef, VPlugToStrip, VPlugToStripRendered, libs.zad_DeviousPlugVaginal, true, true )
			EndIf
		Endif

		If APlugToStrip && !APlugToStrip.HasKeyword( libs.zad_BlockGeneric )
			;Debug.Notification( "Generic anal plug found, is removable" )
			;check if it's a locking plug, only unlocked with a chastity key
			If APlugToStrip.HasKeyword( libs.zad_Lockable )
				If libs.PlayerRef.GetItemCount( libs.chastityKey ) >= 1
					Armor APlugToStripRendered = libs.GetRenderedDevice( APlugToStrip )
					libs.PlayerRef.RemoveItem( libs.chastityKey, 1 )
					libs.UnlockDevice( libs.PlayerRef, APlugToStrip, APlugToStripRendered, libs.zad_DeviousPlugAnal, true, true )
					StrippedAPlug = APlugToStrip
					Debug.Notification( Unlocker.GetLeveledActorBase().GetName() + " took a key you were carrying and managed to unlock your anal plug!" )
				ElseIf Unlocker.GetItemCount( libs.chastityKey ) >= 1
					Armor APlugToStripRendered = libs.GetRenderedDevice( APlugToStrip )
					Unlocker.RemoveItem( libs.chastityKey, 1 )
					libs.UnlockDevice( libs.PlayerRef, APlugToStrip, APlugToStripRendered, libs.zad_DeviousPlugAnal, true, true )
					StrippedAPlug = APlugToStrip
					Debug.Notification( Unlocker.GetLeveledActorBase().GetName() + " used a key they were carrying and managed to unlock your anal plug!" )
				EndIf
			Else			
				Armor StrippedAPlugRendered = libs.GetRenderedDevice( APlugToStrip )
				StrippedAPlug = APlugToStrip
				libs.UnlockDevice( libs.PlayerRef, APlugToStrip, StrippedAPlugRendered, libs.zad_DeviousPlugAnal, true, true )
			EndIf
		Endif
	EndIf
EndFunction

;used to add additional sex partner(s) to the scene
Bool Function Gangbang( Actor Partner, Actor Victim, String Hook )
	;start only if the player is not bound and the roll is successful
	If !libs.PlayerRef.WornHasKeyword( libs.zad_DeviousHeavyBondage ) && ( Utility.RandomFloat( 0.0, 100.0 ) <= din_cfg.GangBangChance )

		FreeUseScanSpell.Cast( libs.PlayerRef )
		Utility.Wait( 1.0 )

		;proceed only if there are valid additional sex partners found
		If ScannedSexPartners.GetSize() > 0
			;remove the already selected partner from the list
			If ScannedSexPartners.HasForm( Partner )
				ScannedSexPartners.RemoveAddedForm( Partner )
			EndIf

			;if only one applicable sex partner is found and that one is the already selected partner, then no threesome
			Int i = 0
			Actor SecondPartner = None

			While ( SecondPartner == None && i < ScannedSexPartners.GetSize() )
				;select one applicable sex partner randomly
				Actor TestPartner = ScannedSexPartners.GetAt( i ) as Actor
				;if partner is an NPC, only select another NPC as the second partner
				If Partner.HasKeywordString( "ActorTypeNPC" ) && TestPartner.HasKeywordString( "ActorTypeNPC" ) && !( TestPartner.HasKeywordString( "ActorTypeAnimal" ) || TestPartner.HasKeywordString( "ActorTypeCreature" ) )
					If ( Partner.GetParentCell() == libs.PlayerRef.GetParentCell() && Partner.Is3DLoaded() )
						SecondPartner = TestPartner
					EndIf
				;if partner is a creature, only select another creature as the second partner
				ElseIf ( Partner.HasKeywordString( "ActorTypeAnimal" ) || Partner.HasKeywordString( "ActorTypeCreature" ) ) && ( TestPartner.HasKeywordString( "ActorTypeAnimal" ) || TestPartner.HasKeywordString( "ActorTypeCreature" ) ) && !( TestPartner.HasKeywordString( "ActorTypeNPC" ) )
					;in the case of creatures, their races also need to match
					If Partner.GetLeveledActorBase().GetRace() == SecondPartner.GetLeveledActorBase().GetRace()
						If ( Partner.GetParentCell() == libs.PlayerRef.GetParentCell() && Partner.Is3DLoaded() )
							SecondPartner = TestPartner
						EndIf
					EndIf
				EndIf
				i += 1
			EndWhile

			;continue only if a fitting second sex partner is actually selected
			If SecondPartner != None
				Debug.Notification( Partner.GetLeveledActorBase().GetName() + " and " + SecondPartner.GetLeveledActorBase().GetName() + " are going to share you!" )	
	
				Actor[] SexActors = new Actor[3]
				SexActors[0] = libs.PlayerRef
				SexActors[1] = Partner
				SexActors[2] = SecondPartner

				String IncludeTags = ""

				;go for vaginal animations if a chastity belt was unlocked
				If StrippedBelt
					IncludeTags += "vaginal"
				EndIf
	
				libs.StartValidDDAnimation( SexActors = SexActors, includetag = IncludeTags, victim = Victim, hook = Hook )
				Return True
			Else
				LogWarning( "Failed to add valid additional sex partner to scene" )
				Return False
			EndIf
		Else
			LogInfo( "No potential additional sex partners found" )
			Return False
		EndIf
	Else
		Return False
	EndIf
EndFunction

;handles the events after a sex scene
Event AfterSexHook( int threadID, bool hasPlayer )

	UnregisterForModEvent( "HookAnimationEnd_AfterSex" )

	;add the stripped belts and plugs back to the player
	If StrippedAPlug != None
		libs.LockDevice( libs.PlayerRef, StrippedAPlug, true )
		StrippedAPlug = None
	EndIf

	If StrippedVPlug != None
		libs.LockDevice( libs.PlayerRef, StrippedVPlug, true )
		StrippedVPlug = None
	EndIf

	If StrippedBelt != None
		libs.LockDevice( libs.PlayerRef, StrippedBelt, true )
		Debug.Notification( "Your chastity belt has been locked back on you!" )
		StrippedBelt = None
	EndIf

	;chance to get tied up after sex, chance shared with random restraint chance - configurable in the mcm
	If Utility.RandomFloat( 0.0, 100.0 ) < din_cfg.Global_RestrainPlayerChance.GetValue()
		Debug.Notification( "A new restraint has been locked on you!" )
		din_mn.RestrainPlayer()
	EndIf

	;chance to drop a slut coin for humiliating effect
	If Utility.RandomFloat( 0.0, 100.0 ) < 33.3
		Debug.Notification( "A piece of gold is dropped at your feet for your 'services'." )
		libs.PlayerRef.Additem( Gold, 1, True )
		libs.PlayerRef.DropObject( Gold, 1 )
	EndIf

	ReleaseEncounter() ; FLEN

EndEvent

;called when the player is the active participant is a sex scene
Function PlayerFucks( Actor Partner, Bool consensual = True, String TagsToInclude = "", String TagsToSuppress = "" )

	SendModEvent( "dhlp-Suspend" )

	libs.PlayerRef.SetRestrained()

	;holds the victim if it's not a consensual scene
	Actor Victim = None

	If ( consensual == False )
		Victim = Partner
	EndIf

	;starting tags, to be expanded based on tags in parameters and partner sex
	String IncludeTags = ""
	String SuppressTags = "foreplay"

	Actor[] SexActors = new Actor[2]
	SexActors[0] = Partner
	SexActors[1] = libs.PlayerRef
	
	;get the sex of the NPC, for proper animation selection
	If Partner.GetLeveledActorBase().GetSex() == 1
		;this is the partner = female branch, lesbian animations are preferable if available
		IncludeTags = TagsToInclude + ",FF"
		SuppressTags += TagsToSuppress
		;check if there are available proper lesbian animations
		sslBaseAnimation[] SAnims = libs.SelectValidDDAnimations( SexActors, 2, false, IncludeTags, SuppressTags )
		;if there aren't, revert the addition of the FF tag
		If Sanims.Length <= 0
			LogInfo( "No suitable lesbian animation found, clearing tags" )
			IncludeTags = TagsToInclude
		EndIf
	ElseIf Partner.GetLeveledActorBase().GetSex() == 0
		;this is the parter = male branch, lesbian animations are suppressed
		IncludeTags = TagsToInclude
		SuppressTags += TagsToSuppress + ",lesbian,FF"
	EndIf

	libs.StartValidDDAnimation( SexActors = SexActors, includetag = IncludeTags, suppresstag = SuppressTags, victim = Victim )

	libs.PlayerRef.SetRestrained( false )

	SendModEvent( "dhlp-Resume" )
	
EndFunction

;=================================================================================================SEX END=================================================================================================

;============================================================================================FLEN START============================================================================================

bool Function CanClaimEncounter()
	if Game.GetModbyName("FluentEncounters.esp") != 255
		return (Quest.GetQuest("Flen_Core") as Flen_Core).Claim("Devious Interests Event")
	endif
	return True
EndFunction

Function ReleaseEncounter()
	if Game.GetModbyName("FluentEncounters.esp") != 255
		(Quest.GetQuest("Flen_Core") as Flen_Core).Release("Devious Interests Event")
	endif
EndFunction

;============================================================================================FLEN END============================================================================================